var map;
var markersArray = [];
var map_canvas;
var center_latlng;
var leftdown_latlng;
var rightup_latlng;
var timeCount=0;
var divLat = 0;
var divLng = 0;

// 地图初始化加载
function initialize(lat, lng, resultJson) {
	var myLatlng = new google.maps.LatLng(lat, lng);
	var myOptions = {
		zoom : 13,
		center : myLatlng,
		
		mapTypeId : google.maps.MapTypeId.ROADMAP
	}
	map_canvas = document.getElementById("map_canvas");
	map = new google.maps.Map(map_canvas, myOptions);
	var marker = new google.maps.Marker({
        position: myLatlng, 
        map: map
    });
	
//	addMarker(myLatlng,"12345","http://i.iaround.net/201109/10/1007df8e92bc8feda5711389a061001b.png");
	//拖动事件
	google.maps.event.addListener(map, "dragend", function() {
		getLocal();
	});
	
	//地图放大缩小事件
	google.maps.event.addListener(map, "zoom_changed", function() {
		getLocal();
	});
	getLocal();
}

//请求本地数据
function getLocal(){
	timeCount++;
	//当地图未加载完成时，是无法获取到Bounds值的
	var bounds = map.getBounds();
	if(bounds!= null&& bounds != undefined){
		timeCount =0;
		center_latlng = map.getCenter();
		var rightup =  bounds.getNorthEast();
		var leftdown = bounds.getSouthWest();			
		//若移动地图发生1/2的变化或第一次加载时		
		if(divLat==0 || Math.abs(rightup.lat()-rightup_latlng.lat())>=divLat/2 || Math.abs(rightup.lng()-rightup_latlng.lng())>=divLng/2){
			rightup_latlng = rightup;
			leftdown_latlng = leftdown;
			alert("iaround,2,"+parseInt(center_latlng.lat()*1000000)+","+parseInt(center_latlng.lng()*1000000)+","+parseInt(rightup_latlng.lat()*1000000)+","+parseInt(rightup_latlng.lng()*1000000)+","+parseInt(leftdown_latlng.lat()*1000000)+","+parseInt(leftdown_latlng.lng()*1000000));
		}
		//计算地图长宽范围
		divLat = rightup_latlng.lat()-leftdown_latlng.lat();
		divLng = rightup_latlng.lng()-leftdown_latlng.lng();
	}else{
		if(timeCount<3){
			setTimeout("getLocal()",300);
		}
	}
}

// 绘制地图上的用户分布
function drawMember(resultJson) {
	if (resultJson != null && resultJson != undefined) {
		var members = resultJson.users;
		if (members != null && members != undefined) {
			clearOverlays();//先清除数据在添加
			for ( var i = 0; i < members.length; i++) {
				var member = members[i];
				if (member.lat != 0 && member.lng != 0) {
					var latLng = new google.maps.LatLng(member.lat / 1000000,member.lng / 1000000);
					addMarker(latLng,member.user.userid,member.user.icon);
				}
			}
		}
	}
}

//生成用户头像
function addMarker(location,id,icon) {
//	//头像
	var image1 = new google.maps.MarkerImage(mySubstring(icon),
			new google.maps.Size(56, 73),
		      new google.maps.Point(0,0),
		      new google.maps.Point(-2, 71),
		      new google.maps.Size(51, 51));
//	//背景图
	var shadow1 = new google.maps.MarkerImage('map_mark_bg.png',
			  new google.maps.Size(56, 73),
		      new google.maps.Point(0,0),
		      new google.maps.Point(0, 73));
	var marker = new google.maps.Marker( {
		position:location,
		map:map,
		shadow:shadow1,
		icon:image1
	});	
	
//	google.maps.event.addListener(marker, 'click', function(){
//		//由于各种原因使用这种方式与本地代码交互
//		alert("iaround,1,"+id); 
//	});
	markersArray.push(marker);
}

//清除地图上的标记
function clearOverlays() {
	if (markersArray) {
		for (i in markersArray) {
			markersArray[i].setMap(null);
		}
	}
}

//获取头像缩略图
function mySubstring(url){
	var last = url.substring(url.lastIndexOf("."), url.length);
	var start = url.substring(0, url.lastIndexOf("."));
	return start + "_s" + last;
}
